package Presenter.Import;

import Model.Arrangement;
import Model.Line;
import com.opencsv.CSVReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.List;
import java.util.Observable;
import java.util.concurrent.ThreadLocalRandom;
import javax.swing.JOptionPane;


/**
 * Implementierung verschiedener Algorithmen zur Berechnung von Ausgleichsgeraden.
 *
 * @Author: Armin Wolf
 * @Email: a_wolf28@uni-muenster.de
 * @Date: 21.06.2017.
 */
public class DataImporter extends Observable{

  private File file;
  private CSVReader reader;
  private Arrangement model;

  public DataImporter(File file, Arrangement model) {
    this.model = model;
    this.file = file;
    try {

      this.reader = new CSVReader(new FileReader(file));
    } catch (FileNotFoundException e) {
      e.printStackTrace();
    }
  }

  public void run(){

    try {
      List<String[]> lines = reader.readAll();
      int counter = 0;
      String[] result = {"import", lines.size()+"", ""};
      //System.out.println("+-------------------------------------------------------------------------------+");
      for(String[] nextLine : lines) {
        counter++;
        // nextLine[] is an array of values from the line
        int id = Integer.parseInt(nextLine[0]);
        Double x = Double.parseDouble(nextLine[1]);
        Double y = Double.parseDouble(nextLine[2]);
        Line line = new Line(x,y);
        line.setId(id+"");
        model.addLine(line);
        //System.out.format("|\t\t\t\t\t %-11d \t|\t\t\t\t\t %-11f \t|\t\t\t\t\t %-11f \t\t\t\t\t|\n", id,x,y);
        setChanged();
        result[2] = counter + "";
        notifyObservers(result);
      }

      //System.out.println("+-------------------------------------------------------------------------------+");
    } catch (IOException e) {
      e.printStackTrace();
    }

  }
}
